/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.dns.models;

/**
* Represents the properties of the zone.
*/
public class ZoneProperties {
    private Long maxNumberOfRecordSets;
    
    /**
    * Optional. Gets or sets the maximum number of record sets that can be
    * created in this zone.
    * @return The MaxNumberOfRecordSets value.
    */
    public Long getMaxNumberOfRecordSets() {
        return this.maxNumberOfRecordSets;
    }
    
    /**
    * Optional. Gets or sets the maximum number of record sets that can be
    * created in this zone.
    * @param maxNumberOfRecordSetsValue The MaxNumberOfRecordSets value.
    */
    public void setMaxNumberOfRecordSets(final Long maxNumberOfRecordSetsValue) {
        this.maxNumberOfRecordSets = maxNumberOfRecordSetsValue;
    }
    
    private Long numberOfRecordSets;
    
    /**
    * Optional. Gets or sets the current number of record sets in this zone.
    * @return The NumberOfRecordSets value.
    */
    public Long getNumberOfRecordSets() {
        return this.numberOfRecordSets;
    }
    
    /**
    * Optional. Gets or sets the current number of record sets in this zone.
    * @param numberOfRecordSetsValue The NumberOfRecordSets value.
    */
    public void setNumberOfRecordSets(final Long numberOfRecordSetsValue) {
        this.numberOfRecordSets = numberOfRecordSetsValue;
    }
}
