/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.resources.models;

/**
* Deployment properties.
*/
public class DeploymentProperties {
    private DeploymentMode mode;
    
    /**
    * Optional. Gets or sets the deployment mode.
    * @return The Mode value.
    */
    public DeploymentMode getMode() {
        return this.mode;
    }
    
    /**
    * Optional. Gets or sets the deployment mode.
    * @param modeValue The Mode value.
    */
    public void setMode(final DeploymentMode modeValue) {
        this.mode = modeValue;
    }
    
    private String parameters;
    
    /**
    * Optional. Deployment parameters. Use only one of Parameters or
    * ParametersLink.
    * @return The Parameters value.
    */
    public String getParameters() {
        return this.parameters;
    }
    
    /**
    * Optional. Deployment parameters. Use only one of Parameters or
    * ParametersLink.
    * @param parametersValue The Parameters value.
    */
    public void setParameters(final String parametersValue) {
        this.parameters = parametersValue;
    }
    
    private ParametersLink parametersLink;
    
    /**
    * Optional. Gets or sets the URI referencing the parameters. Use only one
    * of Parameters or ParametersLink.
    * @return The ParametersLink value.
    */
    public ParametersLink getParametersLink() {
        return this.parametersLink;
    }
    
    /**
    * Optional. Gets or sets the URI referencing the parameters. Use only one
    * of Parameters or ParametersLink.
    * @param parametersLinkValue The ParametersLink value.
    */
    public void setParametersLink(final ParametersLink parametersLinkValue) {
        this.parametersLink = parametersLinkValue;
    }
    
    private String template;
    
    /**
    * Optional. Gets or sets the template content. Use only one of Template or
    * TemplateLink.
    * @return The Template value.
    */
    public String getTemplate() {
        return this.template;
    }
    
    /**
    * Optional. Gets or sets the template content. Use only one of Template or
    * TemplateLink.
    * @param templateValue The Template value.
    */
    public void setTemplate(final String templateValue) {
        this.template = templateValue;
    }
    
    private TemplateLink templateLink;
    
    /**
    * Optional. Gets or sets the URI referencing the template. Use only one of
    * Template or TemplateLink.
    * @return The TemplateLink value.
    */
    public TemplateLink getTemplateLink() {
        return this.templateLink;
    }
    
    /**
    * Optional. Gets or sets the URI referencing the template. Use only one of
    * Template or TemplateLink.
    * @param templateLinkValue The TemplateLink value.
    */
    public void setTemplateLink(final TemplateLink templateLinkValue) {
        this.templateLink = templateLinkValue;
    }
}
