/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.sql.models;

import com.microsoft.windowsazure.core.LazyArrayList;
import com.microsoft.windowsazure.core.OperationResponse;

import java.util.ArrayList;

/**
* Represents Azure SQL Database Elastic Pool metric definitions.
*/
public class ElasticPoolMetricDefinitions extends OperationResponse {
    private ArrayList<MetricDefinition> metricDefinitions;
    
    /**
    * Optional. Gets or sets the list of Azure Sql Elastic Pool metric
    * definitions.
    * @return The MetricDefinitions value.
    */
    public ArrayList<MetricDefinition> getMetricDefinitions() {
        return this.metricDefinitions;
    }
    
    /**
    * Optional. Gets or sets the list of Azure Sql Elastic Pool metric
    * definitions.
    * @param metricDefinitionsValue The MetricDefinitions value.
    */
    public void setMetricDefinitions(final ArrayList<MetricDefinition> metricDefinitionsValue) {
        this.metricDefinitions = metricDefinitionsValue;
    }
    
    /**
    * Initializes a new instance of the ElasticPoolMetricDefinitions class.
    *
    */
    public ElasticPoolMetricDefinitions() {
        super();
        this.setMetricDefinitions(new LazyArrayList<MetricDefinition>());
    }
}
